Attribute VB_Name = "m_CStr"
'' Property Editor Active-X Control
''
'' Version 1.0
''
''
'' m_CStr.bas - CString / BString conversion tools.

'' Copyright (C) 2000 The Southern Cross.
'' All Rights Reserved.

'' Unauthorized Commercial Use Strictly Prohibited.
''

Option Explicit

Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Public Function padstr(ByVal Value As Long, Optional ByVal FixLen = 6, Optional ByVal HexTxt As Boolean = False) As String
    Dim sA As String
        
    If (HexTxt = True) Then
        sA = Hex(Value)
    Else
        sA = Value
    End If
    
    If (Len(sA) < FixLen) Then
        padstr = String(FixLen - Len(sA), " ") + sA
    Else
        padstr = sA
    End If

End Function

Public Sub tobytes(dest() As Byte, ByVal src As String)
    Dim i As Long, _
        j As Long, _
        s As String
    
    s = StrConv(src, vbFromUnicode)
    i = Len(src)
    
    CopyMemory dest(0), ByVal StrPtr(s), i
    dest(i) = 0
    
End Sub

Public Function strcat(dest() As Byte, src() As Byte, Optional Index As Long = 0) As Long
    Dim i As Long, _
        z As Long
    
    On Error Resume Next
    i = -1
    i = UBound(dest)
    If i = -1 Then Exit Function
    
    i = -1
    i = UBound(src)
    If i = -1 Then Exit Function
    
    z = UBound(dest)
    
    For i = Index To z
        If dest(i) = 0 Then Exit For
        
    Next i
        
    If i <= z Then
        For z = 0 To UBound(src)
            If src(z) = 0 Then Exit For
        Next z
        
        CopyMemory dest(i), src(0), z
        strcat = i + z
        Exit Function
        
    End If
    
End Function


Public Function CStrToString(bArray() As Byte) As String
    Dim i As Long
    
    On Error Resume Next
    
    i = -1
    i = LBound(bArray)
    If i < 0 Then Exit Function
    
    For i = LBound(bArray) To UBound(bArray)
    
        If bArray(i) = 0 Then Exit For
        CStrToString = CStrToString + Chr(bArray(i))
    
    Next i
    
End Function

Public Function StringToCStr(sData As String, bArray() As Byte, Optional ByVal Fixed As Boolean = True)
    
    Dim i As Long, _
        n As Long
    
    If Not Fixed Then
        ReDim bArray(0 To Len(sData))
    Else
        
        If (((UBound(bArray) - LBound(bArray)) + 1) < Len(sData) + 1) Then Exit Function
        
    End If

    n = LBound(bArray)
    For i = 1 To Len(sData)
    
        bArray(n) = Asc(Mid(sData, i, 1))
        n = n + 1
    
    Next i
    
    bArray(n) = 0

End Function


